﻿namespace Section4_2.ViewModels
{
    using System.Collections;
    using System.Linq;
    using YKToolkit.Bindings;

    public class MainViewModel : NotificationObject
    {
        /// <summary>
        /// 新しいインスタンスを生成します。
        /// </summary>
        public MainViewModel()
        {
            SetRandomData();
        }

        #region 公開プロパティ
        private IEnumerable data1;
        /// <summary>
        /// 1 つ目のサンプルデータのデータ列を取得または設定します。
        /// </summary>
        public IEnumerable Data1
        {
            get { return data1; }
            set { SetProperty(ref data1, value); }
        }

        private IEnumerable data2;
        /// <summary>
        /// 2 つ目のサンプルデータのデータ列を取得または設定します。
        /// </summary>
        public IEnumerable Data2
        {
            get { return data2; }
            set { SetProperty(ref data2, value); }
        }
        #endregion 公開プロパティ

        /// <summary>
        /// ランダムなグラフデータを生成します。
        /// </summary>
        private void SetRandomData()
        {
            var rnd = new System.Random();

            Data1 = Enumerable.Range(0, 3).Select(_ => rnd.Next(20, 80));
            Data2 = Enumerable.Range(0, 3).Select(_ => rnd.Next(20, 80));
        }
    }
}
