﻿namespace Section4_3.ViewModels
{
    using Section4_3.Models;
    using YKToolkit.Bindings;

    public class MainViewModel : NotificationObject
    {
        /// <summary>
        /// サンプルモデルのインスタンス
        /// </summary>
        private SampleModel model = new SampleModel();

        #region 公開プロパティ
        private bool isBusy;
        /// <summary>
        /// ビジー状態かどうかを取得します。
        /// </summary>
        public bool IsBusy
        {
            get { return isBusy; }
            private set { SetProperty(ref isBusy, value); }
        }
        private string message;
        /// <summary>
        /// メッセージを取得または設定します。
        /// </summary>
        public string Message
        {
            get { return message; }
            set { SetProperty(ref message, value); }
        }

        private DelegateCommand buttonCommand;
        /// <summary>
        /// ボタンのコマンドを取得します。
        /// </summary>
        public DelegateCommand ButtonCommand
        {
            get
            {
                if (buttonCommand == null)
                    buttonCommand = new DelegateCommand(_ =>
                    {
                        DoCommand();
                    });
                return buttonCommand;
            }
        }
        #endregion 公開プロパティ

        /// <summary>
        /// 処理をおこないます。
        /// </summary>
        private async void DoCommand()
        {
            Message = "処理を開始します。";
            IsBusy = true;

            // 重たい処理を非同期でおこなう
            await model.DoHeavyWorkAsync();

            IsBusy = false;
            Message = "処理を終了しました。";
        }
    }
}
