﻿namespace Section4_7.Views
{
    using System.Windows.Controls;
    using YKToolkit.Controls;

    /// <summary>
    /// MainView.xaml の相互作用ロジック
    /// </summary>
    public partial class MainView : Window
    {
        public MainView()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Drop イベントハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RootNodeTextBox_Drop(object sender, System.Windows.DragEventArgs e)
        {
            var item = e.Data.GetData(typeof(TreeViewItem)) as TreeViewItem;
            if (item != null)
            {
                var data = item.Header as FileTreeNode;
                if (data != null)
                {
                    // YKToolkit.Controls.FileTreeNode がドロップされたらそのフルパスを受け取る
                    RootNodeTextBox.Text = data.NodeInfo.FullName;
                }
            }
        }

        /// <summary>
        /// PreviewDragOver イベントハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RootNodeTextBox_PreviewDragOver(object sender, System.Windows.DragEventArgs e)
        {
            // DragOver イベントをここで中断させる
            e.Handled = true;
        }
    }
}
